import { PrimaryGeneratedColumn, Column } from "typeorm";
import {
  IsInt,
  IsNotEmpty,
  IsOptional,
  IsPositive,
} from "class-validator";

/**
 * Defines the scan interface.
*/
export abstract class Scan {
  /**
   * Autogenerated unique id (primary key).
   */
  @PrimaryGeneratedColumn()
  @IsOptional()
  @IsInt()
  id: number;

  /**
   * The associated runner.
   */
  @Column()
  @IsNotEmpty()
  //TODO: Relationship
  runner: Runner;

  /**
   * The scan's distance in meters.
   */
  @Column()
  @IsInt()
  @IsPositive()
  distance: number;
}
